/*jslint nomen: true*/
/*global define*/
define('de_epages/externalcontent/gadgetdialog/over-view', [
    'de_epages/externalcontent/gadgetdialog/JSONGetGadgetInformation',
    // path relative to baseUrl as defined in require.config.paths,
    // see /Cartridges/DE_EPAGES/Presentation/Templates/Backoffice-JQueryConfig.Page.js
    'jquery',
    'underscore',
    'backbone',
    '$dict!../dictionary',
    '$tmpl!./over-view'
], function (gadgetData, $, _, Backbone, dict, template) {

    'use strict';

    var translatedGadgetData = $.extend(true, {}, gadgetData);

    // Translate aliases of gadgets.
    _.each(translatedGadgetData.GadgetGroups, function (group) {
        _.each(group.Gadgets, function (gadget) {
            gadget.AliasTranslation = dict.translate(gadget.Alias.toLowerCase());
        });
    });
    /*
     * Hi DE_EPAGES/Test/API/TranslationJS.pm, I know you can't really interpret javascript.
     * Let me help you understand what just happened.
     *
     * dict.translate('rss')
     * dict.translate('maps')
     * dict.translate('externalvideo')
     * dict.translate('facebook')
     * dict.translate('twitter')
     * dict.translate('googleplus')
     * dict.translate('otherbuttons')
     * dict.translate('externalvideo')
     * dict.translate('contentslider')
     *
     * You know, $PERL, someday we will just use node.js for these kind of tests, so do not worry.
     */

    return Backbone.View.extend({

        tagName: 'div',

        dict: dict,

        events: {
            'change input:radio[name=gadgetselection]': 'select'
        },

        render: function () {
            this.$el.append(template(translatedGadgetData));
            return this;
        },

        select: function (e) {
            var $target = $(e.target);
            if ($target.is('img')) {
                $target = $target.parent();
            }
            // Let *main-view* know what happend.
            this.trigger('select', {
                alias: $target.data('alias').toLowerCase()
            });
        }

    });

});