define(['testsuite/qunit', 'jquery', 'ep/ajax'], function (QUnit, $, ep) {

	QUnit.module("ep/ajax");

	QUnit.asyncTest("ep/ajax", function () {

		var results = {},
			jqXHR;

		$.each([0,1,2], function( i, name ){
			jqXHR = ep.ajax({
				url: 'ajax-test-' + i + '.json',
				type: 'get',
				async: false,
				dataType: 'json',
				success: function( data ){
					results[i] = ['success', data];
				},
				error: function( xhr, status, error ){
					results[i] = ['error', error];
				}
			});
		});

		QUnit.deepEqual(
			results[0],
			['error', 'Not Found'],
			"ep.ajax({...})"
		);
		QUnit.deepEqual(
			results[1],
			['success', {"Delete":"Löschen","New":"Neu"}],
			"ep.ajax({...})"
		);
		QUnit.deepEqual(
			results[2],
			['error', {"msg":"customError"}],
			"ep.ajax({...})"
		);

		QUnit.start();
	});
});