define(['testsuite/qunit', 'jquery', 'ep/alert', 'testsuite/simulate', '$ready!'], function (QUnit, $, ep) {

	QUnit.module("ep/alert");

	QUnit.asyncTest("ep/alert", function () {

		var resultOk = 0,
			resultCancel = 0,
			resultClose = 0,

			resultReset = function(){
				dialog.uiDialog('open');
				resultOk = 0
				resultCancel = 0
				resultClose = 0;
			};

		// run alert
		var dialog = ep.alert({
				title: 'TestTitle',
				content: 'Test',
				ok: function(){
					resultOk++;
				},
				cancel: function(){
					resultCancel++;
				},
				close: function(){
					resultClose++;
				},
				type: 'Warning'
			});

		// dialog exists
		QUnit.equal(
			$('body > div.ui-dialog').length,
			1,
			"$('body > div.ui-dialog').length"
		);
		
		// Existing dialog is an (ep) .uiDialog
		QUnit.equal(
			$('.epDialog').length,
			1,
			"$('.epDialog').length"
		);
		
		// Click ok on opened dialog
		dialog.uiDialog("open");
		$('.ui-dialog-buttonset button:eq(0)').simulate("click");

		QUnit.equal(
			resultOk,
			1,
			"run ok() on click Ok"
		);

		// click Ok / Cancel
		// trigger by javascript does not work, the originalTarget will replaced
		// on manual click it works fine
		
/*
		// Click cancel on opened dialog
		dialog.uiDialog("open");
		$('.ui-dialog-buttonset button:eq(1)').simulate("click");

		QUnit.equal(
			resultCancel,
			1,
			"run cancel() on click Cancel"
		);
		
		// Click close on opened dialog
		dialog.uiDialog("open");
		$('.ui-dialog-titlebar-close').simulate("click");

		QUnit.equal(
			resultClose,
			1,
			"run close() on click Close"
		);
*/

		// Press ESC
		dialog.uiDialog("open");
		$(dialog)
			.simulate("keydown", { keyCode: $.ui.keyCode.ESCAPE })
			.simulate("keypress", { keyCode: $.ui.keyCode.ESCAPE })
			.simulate("keyup", { keyCode: $.ui.keyCode.ESCAPE });

		QUnit.equal(
			resultCancel,
			1,
			"run cancel() on press Escape button"
		);

		// reset
		resultReset();

		QUnit.start();

	});
});