define(['testsuite/qunit', 'jquery', 'ep/ui/tooltip', '$ready!'], function (QUnit, $, ep) {

	QUnit.module("ep/ui/tooltip");

	QUnit.asyncTest("ep/ui/tooltip", function() {

		var toolTipParent = $('#ToolTipParent').parent();

		$('#newToolTip').uiTooltip({
			context: '#ToolTipContext',				//$('<div>').appendTo($('body')).text('Click me 2')
			offsetAdjust: [0,19]
		});

		$('#newToolTip2').uiTooltip({
			context: '#ToolTipContextInteractive',
			offsetAdjust: [0,19],
			interactive: true
		});
		$('#newToolTip3').uiTooltip({
			context: '#ToolTipPositionContext3',
			positionType: 'context',
			orientation: 'top,right'
		});
		$('#newToolTip4').uiTooltip({
			context: '#ToolTipPositionContext4',
			positionType: 'context',
			orientation: 'bottom,left'
		});
		$('#newToolTip5').uiTooltip({
			context: '#ToolTipPositionContext5',
			positionType: 'context',
			orientation: 'bottom,right'
		});
		$('#newToolTip6').uiTooltip({
			context: '#ToolTipPositionContext6',
			positionType: 'context',
			orientation: 'top,left'
		});
		$('#newToolTip7').uiTooltip({
			context: '#ToolTipPositionContext7',
			positionType: 'context',
			orientation: 'top'
		});
		$('#newToolTip8').uiTooltip({
			context: '#ToolTipPositionContext8',
			positionType: 'context',
			orientation: 'right'
		});
		$('#newToolTip9').uiTooltip({
			context: '#ToolTipPositionContext9',
			positionType: 'context',
			orientation: 'bottom'
		});
		$('#newToolTip10').uiTooltip({
			context: '#ToolTipPositionContext10',
			positionType: 'context',
			orientation: 'cursor'
		});
		$('#newToolTip11').uiTooltip({
			context: '#ToolTipPositionContext11',
			positionType: 'context',
			orientation: 'top,center'
		});
		$('#newToolTip12').uiTooltip({
			context: '#ToolTipPositionContext12',
			positionType: 'context',
			orientation: 'center'
		});
		$('#newToolTip13').uiTooltip({
			context: '#ToolTipPositionContext13',
			positionType: 'context',
			orientation: 'bottom,center'
		});

		//console.debug($('#newToolTip').uiTooltip('destroy'));
		//$('#newToolTip').uiTooltip._onClick();
		//console.debug($('<!-- -->').appendTo($('body')));
		$('#ToolTipParent').uiTooltip({
			context: 'parent',
			orientation: 'right',
			interactive: true
		});
		$('#ToolTipPrev').uiTooltip({
			context: 'prev',
			orientation:'right'
		});
		$('#ToolTipNext').uiTooltip({
			context: 'next',
			orientation:'right'
		});
		$('#ToolTipChangeOption').uiTooltip({
			context: 'next',
			orientation:'right'
		});
		$('#ToolTipCloseButton').uiTooltip({
			context: '#ToolTipContextCloseButton',
			interactive: true,
			closeButton: true
		});

		//This happens before the functions in asyncTest() will be executed.
		$('#ToolTipNext').uiTooltip('destroy');
		QUnit.equal($("#ToolTipNext:visible").length, 1, "Tooltip content is visible after destroying");
		QUnit.equal($("#ToolTipNext").parent().hasClass('ep-uiTooltip'), false, "The parent tooltip <div> got removed");

		//Show tooltips for asyncTest.
		$('#ToolTipContextInteractive').trigger('mouseenter');
		$('#ToolTipPositionContext5').trigger('mouseenter');
		$('#ToolTipPositionContext12').trigger('mouseenter');
		toolTipParent.trigger('mouseenter');
		$('#ToolTipPrevContext').trigger('mouseenter');
		$('#ToolTipPositionContext10').trigger('mouseenter');
		$('#ToolTipContextCloseButton').trigger('mouseenter');
		$('#newToolTip3').uiTooltip('show');

		//Change option.
		$('#ToolTipChangeOption').uiTooltip({context: '#ToolTipChangeOptionPrevContext'});

		//We have to store the top position of the context element because the first test result will be visible while the first asyncTest is running.
		var ToolTipPositionContextTop = $('#ToolTipPositionContext5').offset().top;

		//We have to wait till the tooltips are visible.
		setTimeout(function(){
			QUnit.equal(
				$('#newToolTip2').parent().css('display'),
				'block',
				"$('#newToolTip2') is visible by mouseenter"
			);

			QUnit.ok(
				$('#newToolTip2').offset().top > $('#ToolTipContextInteractive').offset().top,
				"The tooltip content's position of $('#newToolTip2') is lower than the context"
			);

			QUnit.equal(
				$('#newToolTip2').offset().left,
				$('#ToolTipContextInteractive').offset().left,
				"The tooltip content's left offset of $('#newToolTip2') is the same like the context"
			);

			QUnit.ok(
				$('#newToolTip5').offset().top > ToolTipPositionContextTop,
				"The tooltip content's position of $('#newToolTip5') is lower than the context"
			);

			QUnit.ok(
				$('#newToolTip5').offset().left > $('#ToolTipPositionContext5').offset().left,
				"The tooltip content's position of $('#newToolTip5') is right to the context"
			);

			QUnit.equal(
				$('#newToolTip12').parent().css('display'),
				'block',
				"$('#newToolTip12') is visible by mouseenter"
			);

			QUnit.equal(
				$('#ToolTipParent').parent().css('display'),
				'block',
				"$('#ToolTipParent') is visible by mouseenter"
			);

			QUnit.equal(
				$('#ToolTipPrev').parent().css('display'),
				'block',
				"$('#ToolTipPrev') is visible by mouseenter"
			);

			QUnit.equal(
				$('#newToolTip10').parent().css('display'),
				'block',
				"$('#newToolTip10') is visible by mouseenter"
			);

			QUnit.equal(
				$('#ToolTipCloseButton').parent().css('display'),
				'block',
				"$('#ToolTipCloseButton') is visible by mouseenter"
			);

			QUnit.equal(
				$('#newToolTip3').parent().css('display'),
				'block',
				"$('#newToolTip3') is visible by showing the tooltip"
			);

			//Leave the context to hide tooltips.
			$('#ToolTipContextInteractive').trigger('mouseleave');
			$('#ToolTipPositionContext5').trigger('mouseleave');
			$('#ToolTipPositionContext12').trigger('mouseleave');
			toolTipParent.trigger('mouseleave');
			$('#ToolTipPrevContext').trigger('mouseleave');
			$('#ToolTipPositionContext10').trigger('mouseleave');
			$('#ToolTipCloseButton').next('a').trigger('click');
			$('#newToolTip3').uiTooltip('hide');

			//Interactive test.
			$('#ToolTipParent').trigger('mouseenter');
			$('#ToolTipPrev').trigger('mouseenter');

			//Show tooltip for next AsyncTest.
			$('#ToolTipChangeOptionPrevContext').trigger('mouseenter');

			//We have to wait till the tooltips aren't visible anymore.
			setTimeout(function(){

				QUnit.equal(
					$('#newToolTip2').parent().css('display'),
					'none',
					"$('#newToolTip2') is not visible anymore"
				);

				QUnit.equal(
					$('#newToolTip12').parent().css('display'),
					'none',
					"$('#newToolTip12') is not visible anymore"
				);

				QUnit.equal(
					$('#ToolTipParent').parent().css('display'),
					'block',
					"$('#ToolTipParent') is still visible 'cause it's interactive"

				);
				QUnit.equal(
					$('#ToolTipPrev').parent().css('display'),
					'none',
					"$('#ToolTipPrev') is not visible anymore"
				);

				QUnit.equal(
					$('#newToolTip10').parent().css('display'),
					'none',
					"$('#newToolTip10') is not visible anymore"
				);

				QUnit.equal(
					$('#ToolTipCloseButton').parent().css('display'),
					'none',
					"$('#ToolTipCloseButton') is not visible anymore"
				);

				QUnit.equal(
					$('#newToolTip3').parent().css('display'),
					'none',
					"$('#newToolTip3') is not visible anymore by hiding the tooltip"
				);

				QUnit.equal(
					$('#ToolTipChangeOption').parent().css('display'),
					'block',
					"$('#ToolTipChangeOption') is visible by mouseenter on previous image"
				);

				//Hide the other tooltips.
				$('#ToolTipChangeOptionPrevContext').trigger('mouseleave');
				$('#ToolTipParent').trigger('mouseleave');

				QUnit.start();

			}, 3000);

		}, 500);

	});
});1