define(['testsuite/qunit', 'jquery', 'de_epages/product/ui/customizer', 'jquery/metaparse', 'testsuite/simulate', '$ready!'], function (QUnit, $, de_epages, ep) {

	QUnit.module("de_epages/product/ui/customizer");

	QUnit.asyncTest("de_epages/product/ui/customizer", function () {

		// create new image
		var pdfName = 'magnifier-test-image1.pdf',

			pdfPath = '../../../ep/ui/' + imageName,

			imageName = 'magnifier-test-image1.jpg',

			imagePath = '../../../ep/ui/' + imageName,

			image = new Image();

		image.src = imagePath;

		// area object
		var areas = [{
				areaNo: 0,
				left: 90,
				top: 140,
				width: 200,
				height: 150
			}, // areaNo aus TLE #Position
			{
				areaNo: 1,
				left: 100,
				top: 30,
				width: 180,
				height: 100
			}];

		// inputData
		var inputObj = {
				alias: 'Sunny Side Sommer T-Shirt',
				variation: 'Farbe: grau',
				description: 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Aenean commodo ligula eget dolor. Aenean massa. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Donec quam felis, ultricies nec, pellentesque eu, pretium quis, sem. Nulla consequat massa quis enim.',
				fonts: [{
					name: 'Arial',
					displayName: 'Arial'
				}, {
					name: 'Tahoma',
					displayName: 'Tahoma'
				}, {
					name: 'Times',
					displayName: 'Times'
				}],
				colors: ['#000000', '#ff0000', '#ffff00'],
				fileFormats: ['image/png', 'image/jpeg', 'image/gif'],
				elements: [{
					alias: '_15568',
					type: 'file',
					title: 'Tolles Bild',
					minWidth: 200,
					minHeight: 200
				}, {
					alias: '_15567',
					type: 'text',
					title: 'Toller Text',
					multiline: false,
					maxChars: 100
				}

				]
			};

		// create customizer
		customizer = $('#customizer')
			.productUiCustomizer({
				width: 800,
				height: 500,
				maxWidth: 400,
				maxHeight: 400,
				areas: areas,
				productImg: imagePath,
				operations: {
					scalable: true,
					rotatable: true
				},
				inputData: inputObj,
				debug: true,
				font: { // font attributes
					name: 'Arial', // font family
					size: 12, // font size
					unit: 'pt', // font unit
					color: '#000000', // default font color (from database)
					resizable: true
				},
				data: {
					ChangeObjectID: 12345
				},
				existingLineItemID: 15576,
				webPath: '',
				contents: {
					"15567": {
						"ExistingLineItemID": 15576,
						"FontSize": 12,
						"InnerWidth": 65,
						"Height": 20,
						"Width": 65,
						"ZIndex": 1001,
						"Color": "black",
						"Text": "blablabla",
						"FromTop": 84,
						"Type": "text",
						"Orientation": 0,
						"InnerHeight": 20,
						"FromLeft": 135,
						"AreaID": 0,
						"FontName": "Arial"
					},
					"15568": {
						"ExistingLineItemID": 15576,
						"InnerWidth": 16.904791011236,
						"Height": 14.499,
						"FilePath": imagePath,
						"Width": 16.929,
						"ZIndex": 1002,
						"GUID": "4F964DA7-2D22-427C-9D7D-AC1404373042",
						"FromTop": 2,
						"Type": "file",
						"Orientation": 0,
						"FileName": imageName,
						"InnerHeight": 14.4666,
						"AreaID": 0,
						"FromLeft": 5
					}
				}
			});

		$('.ep-js')
			.metaparse();

		//==================================================================================//
		// BEGIN: TEST
		//==================================================================================//
		setTimeout(function () {
			var widget = $('#customizer')
					.data('uiProductUiCustomizer');

			// is defined
			QUnit.equal(
				$.isFunction($.ui.productUiCustomizer),
				true,
				"$.isFunction($.ui.productUiCustomizer)"
			);

			// check prototype methods
			$.each(['generateCustomizedJSON', 'getBase64Image', 'getBase64PreviewImage', 'getGUIDList', 'sendGUIDasJSON', 'layerUpDown', 'scale', 'rotate', 'removeElement'], function (i, fn) {

				QUnit.equal(
					$.isFunction($.ui.productUiCustomizer.prototype[fn]),
					true,
					"$.isFunction( $.ui.productUiCustomizer.prototype['" + fn + "'] )"
				);

			});

			// check restored settings
			QUnit.equal(
				customizer.find('canvas').length,
				2, "$('#customizer').find('canvas')"
			);

			// select color
			$('.ep-uiCustomizer-fontColor li[data-color="#ff0000"]')
				.trigger('click');

			// check color selection
			QUnit.equal(
				customizer.find('.ep-uiCustomizer-fontColor .selectedColor').data('color'),
				'#ff0000',
				"$('#customizer').find('.ep-uiCustomizer-fontColor .selectedColor').data('color')"
			);

			// select font family
			$('.ep-uiCustomizer-fontFamily option[value="Times"]')
				.trigger('change')
				.attr('selected', 'selected');

			// check font selection
			QUnit.equal(
				customizer.find('.ep-uiCustomizer-fontFamily option:selected').val(),
				'Times',
				"$('#customizer').find('.ep-uiCustomizer-fontFamily option:selected').val()"
			);

			// get GUID List
			QUnit.deepEqual(
				$('#customizer').productUiCustomizer('getGUIDList'),
				["4F964DA7-2D22-427C-9D7D-AC1404373042"],
				"$('#customizer').productUiCustomizer('getGUIDList')"
			);

			var getBase64Image = JSON.stringify($('#customizer')
					.productUiCustomizer('getBase64Image')),
				getBase64PreviewImage = JSON.stringify($('#customizer')
					.productUiCustomizer('getBase64PreviewImage')),
				generateCustomizedJSON = $('#customizer')
					.productUiCustomizer('generateCustomizedJSON');

			/* Due to the performance of different browsers the following tests will lead to different results (during the same time period). Therefore following they are commented out.
		      // check base64Image
		      QUnit.equal(
		        getBase64Image.substr(0,100),
		        '"iVBORw0KGgoAAAANSUhEUgAAAZAAAAGQCAYAAACAvzbMAAAgAElEQVR4nOy9d3Rc13Wo/34vebEKgem9YjCDwQzKoHeit0HvwKA',
		        "$('#customizer').productUiCustomizer('getBase64Image')"
		      );

		      // check base64PreviewImage
		      QUnit.equal(
		        getBase64PreviewImage.substr(0,100),
		        '"iVBORw0KGgoAAAANSUhEUgAAAGQAAABkCAYAAABw4pVUAAAgAElEQVR4nOy9d3Sb933vf8/v15u0aWLLliVZdizJsrWpQQ1uEgS',
		        "$('#customizer').productUiCustomizer('getBase64PreviewImage')"
		      );

		      // check generateCustomizedJSON
		      QUnit.deepEqual(
		        generateCustomizedJSON,
		        { "15567": { "Type": "text", "Height": 19, "Width": 64, "InnerHeight": 19, "InnerWidth": 63, "FromTop": 84, "FromLeft": 135, "ZIndex": 1001, "Orientation": 0, "AreaID": 0, "ExistingLineItemID": 15576, "FontSize": 12, "Color": "#ff0000", "FontName": "Arial", "Text": "blablabla" }, "15568": { "Type": "file", "Height": 17, "Width": 17, "InnerHeight": 17.07383892134836, "InnerWidth": 17.07383892134836, "FromTop": 1, "FromLeft": 4, "ZIndex": 1002, "Orientation": 0, "AreaID": 0, "ExistingLineItemID": 15576, "FileName": "magnifierTest_Image1.jpg", "GUID": "4F964DA7-2D22-427C-9D7D-AC1404373042" }},
		        "$('#customizer').productUiCustomizer('generateCustomizedJSON')"
		      );
			*/

			// check upload and image insert
			var uploadData = [{
					success: {
						FileName: imageName,
						uploadedFile: imagePath
					}
				}],
				uploadDataPDF = [{
					success: {
						FileName: pdfName,
						uploadedFile: pdfPath
					}
				}],
				$input = $('input[data-alias=_15568]');
			// insert new canvas and draw image
			widget._uploaderCallback(uploadData, 'success', '15568', $input);

			// change zIndex for selected canvas
			$('.ep-uiCustomizer-layerUp')
				.trigger('mousedown');
			$('.ep-uiCustomizer-layerUp')
				.trigger('mouseup');

			// check zIndex
			QUnit.equal(
				customizer.find('.ep-uiCustomizer-canvasSelected').css('zIndex'),
				'1002',
				"$('#customizer').find('.ep-uiCustomizer-canvasSelected').css('zIndex')"
			);

			// select canvas
			customizer.find('.ep-uiCustomizer-canvasSelected')
				.trigger('mousedown');
			customizer.find('.ep-uiCustomizer-canvasSelected')
				.trigger('mouseup');

			// simulate a drag n drop event
			widget._selectedCanvas.trigger('mousedown');
			widget._selectedCanvas.simulate('Drag', {
				dx: -80,
				dy: -180
			});
			widget._selectedCanvas.trigger('mouseup');

			// check parent area of selected canvas
			QUnit.equal(
				customizer.find('.ep-uiCustomizer-canvasSelected').parent().data('position'),
				1,
				"$('#customizer').find('.ep-uiCustomizer-canvasSelected').length"
			);
			//alert(JSON.stringify(customizer.find('.ep-uiCustomizer-canvasSelected').parent().data()))

			$('li[data-key=rotateLeft]')
				.trigger('mousedown');

			setTimeout(function () {
				$('li[data-key=rotateLeft]')
					.trigger('mouseup');

				$('li[data-key=scaleDown]')
					.trigger('mousedown');

				setTimeout(function () {
					$('li[data-key=scaleDown]')
						.trigger('mouseup');

					// check rotation angle
					QUnit.equal(
						widget._canvasController[customizer.find('.ep-uiCustomizer-canvasSelected').data('alias')].angle !== 0,
						true,
						"widget._canvasController[customizer.find('.ep-uiCustomizer-canvasSelected').data('alias')].angle !== 0"
					);

					// insert new canvas and draw image
					widget._uploaderCallback(uploadDataPDF, 'success', '15568', $input);

					QUnit.equal(
						customizer.find('canvas').length,
						2,
						"$('#customizer').find('canvas').length"
					);

					// wait for pdf upload
					setTimeout(function () {
						// insert new canvas and draw image
						widget._uploaderCallback(uploadData, 'success', '15568', $input);

						// wait for image upload
						setTimeout(function () {
							// remove selected canvas
							$('#customizer')
								.productUiCustomizer('removeElement');

							// check whether canvas is removed
							QUnit.equal(
								customizer.find('.ep-uiCustomizer-canvasSelected').length,
								0,
								"$('#customizer').find('.ep-uiCustomizer-canvasSelected').length"
							);

							customizer.find('canvas')
								.trigger('mousedown');

							$('#customizer')
								.productUiCustomizer('removeElement');

							customizer.find('canvas')
								.trigger('mousedown');

							$('#customizer')
								.data('uiProductUiCustomizer')
								._removeCanvas();

							// check whether all canvases are removed
							QUnit.equal(
								customizer.find('canvas').length,
								0,
								"$('#customizer').find('canvas').length"
							);

							// insert text canvas
							$input = $('input[data-alias=_15567]');
							$input.val('Feuerstein')
								.trigger('keyup');

							setTimeout(function () {
								$('#customizer')
									.productUiCustomizer('customDestroy');

								QUnit.start();

							}, 500);
						}, 500);
					}, 500);
				}, 1000);
			}, 1000);
		}, 500);
	});
});