-- #102
CREATE TABLE shippingmethod (
     shippingmethodid     integer  not null
,    shopid               integer  not null
,    shippingtypeid       integer  not null
,    taxclassid           integer  null
,    isactivated          bool  not null
,    isdefault            bool  not null
,    containersubtotalattrname varchar(255)  null
,    regionid             integer  null
,    enabledbydefault     bool  not null

,   constraint pk_shippingmethod                primary key (shippingmethodid)
,   constraint fk_shippingmethod_taxclassid     foreign key (taxclassid)
        references taxclass                         (taxclassid)
,   constraint fk_shippingmethod_shopid         foreign key (shopid)
        references shop                             (shopid)
,   constraint fk_shippingmethod_shippingmethodid foreign key (shippingmethodid)
        references object                           (objectid)
,   constraint fk_shippingmethod_shippingtypeid foreign key (shippingtypeid)
        references shippingtype                     (shippingtypeid)
,   constraint fk_shippingmethod_regionid       foreign key (regionid)
        references region                           (regionid)
)
GO
CREATE INDEX i_shipping_shop ON shippingmethod (shopid)
GO

CREATE INDEX i_shipping_type ON shippingmethod (shippingtypeid)
GO

CREATE INDEX i_shipping_taxclass ON shippingmethod (taxclassid)
GO

CREATE INDEX i_shippingmethod_regionid ON shippingmethod (regionid)
GO
