define(['testsuite/qunit', 'jquery', 'de_epages/shopmailtype/ui/placeholderdialog', '$ready!'], function (QUnit, $, de_epages) {

	QUnit.module("de_epages/shopmailtype/ui/placeholderdialog");

	QUnit.asyncTest("de_epages/shopmailtype/ui/placeholderdialog", function () {

		// Check prototype methods.
		$.each(['_create', '_setOption', 'destroy', '_close', '_onTrClick'], function (i, fn) {
			equal(
				$.isFunction($.ui.shopmailtypeUiPlaceholderdialog.prototype[fn]),
				true,
				'$.isFunction(' + fn + '):'
			);
		});

		// Create placeholder.
		var $insertPlaceHolder = $('#ep-insertPlaceHolder').shopmailtypeUiPlaceholderdialog();
		
		QUnit.equal(
			typeof $insertPlaceHolder.data('epUiSimpledialog') === 'object',
			true,
			"typeof $insertPlaceHolder.data('epUiSimpledialog') === 'object'"
		);

		// Open dialog.
		$insertPlaceHolder.trigger('click');

		// Click tr. (Insert first placeholder.)
		$($('table tr').get(1)).trigger('click');

		QUnit.equal(
			$('input[name="Subject"]').val(),
			"#Code0My subject is so pretty",
			'*Placeholder0* inserted at beginning of input with name "Subject"'
		);

		// Change selection in input.
		$('input[name="Subject"]')
			.prop({
				'selectionStart' : 9,
				'selectionEnd' :  16
			});

    // Click tr. (Insert second placeholder.)
		$($('table tr').get(2)).trigger('click');

		QUnit.equal(
			$('input[name="Subject"]').val(),
			"#Code0My #Code1 is so pretty",
			'*Placeholder1* inserted at previous position of "Subject" in input with name "Subject"'
		);

		// Destroy.
		$('#ep-insertPlaceHolder').shopmailtypeUiPlaceholderdialog('destroy');

		QUnit.equal(
			$insertPlaceHolder.data('events'),
			undefined,
			'*click* handler removed'
		);

		QUnit.equal(
			$insertPlaceHolder.data('epUiSimpledialog'),
			undefined,
			'*uiSimpledialog* data attribute removed'
		);

		QUnit.deepEqual(
			$insertPlaceHolder.data('de_epagesShopmailtypeUiPlaceholderdialog'),
			$.parseJSON($insertPlaceHolder.attr('data-de_epages-shopmailtype-ui-placeholderdialog')),
			'*shopmailtypeUiPlaceholderdialog* data attribute removed'
		);

		// Let's go, QUnit!
		QUnit.start();
	});
});